function [k,ru] = curvt(u,d)

% d: escala no dominio do espaco

Np = length(u);
Np1 = Np - 1;
Np2 = floor(Np/2);

U = fft(u);
% tira o DC
DC = U(1); U(1) = 0;

U = fftshift(U);

s = -Np2:(Np1-Np2);

p0 = perim(u);

% filtro
GF = exp((-2*pi^2*d^2*s.^2)/Np^2);

U = U .* GF.'; 
dU = j*2*pi*s/Np .* U.';
ddU = (j*2*pi*s/Np).^2 .* U.';

% reajusta o DC para reconstruir o contorno

U = fftunsh(U).';
U(1) = DC;
ru = ifft(U).'; 
du = ifft(fftunsh(dU).').';
ddu = ifft(fftunsh(ddU).').';

Cp = p0 / ((2*pi/Np)*sum( abs(du)));

% NORMALIZACAO PELO PERIMETRO

ru = ru * Cp;

%du = du * Cp;
%ddu = ddu * Cp;

% Complex Curvature

 k = (-imag( du .* conj(ddu)))./ (abs(du).^3);

% inverte o sinal da curvatura
%k = -k;
