function c = fc_grahamc(u)

%% c = pontos de u representando o fecho convexo de u
%% u = vetor complexo que define o contorno  
%% Calculo do fecho convexo de u atraves do Algoritmo de Graham

global Nmax False True

Nmax  = 100000;
False = 0;
True  = 1;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%plot(u,'.-');
[sx,sy] = remove_pont_reta(real(u),imag(u));
%hold on;plot(sx,sy,'r.-');
n = length(sx);

if ( n < 3 )
    break;
end
%sx = real(u); sy = imag(u);

% calculo do ponto mais embaixo e mais a direita em "s"

w = 1;
for k = 2:n
 if ( sy(k) < sy(w) )
    w = k;
 else
  if ( sy(k) == sy(w) )
    if ( sx(k) > sx(w) )
     w = k; 
    end
  end
 end
end

p0 = [sx(w) sy(w)];

% removemos o ponto p0 = [sx(w),sy(w)]

x = sx; y = sy;
x(w)=[]; y(w)=[];

% ordenaco dos pontos {(sx, sy)}-{p0} em relacao ao angulo polar que estes 
% pontos forman ao redor do ponto p0.

[theta, I] = sort(atan_modif((y-p0(2)),(x-p0(1)))); 
x = x(I); y = y(I);


% inicializamos a pilha T
T = []; m = 0;
[T, m] = cria_pilha(T, m);

[T, m]   = insere_pilha(T,m,p0);
[T, m]   = insere_pilha(T,m,[x(1),y(1)]);
[T, m]   = insere_pilha(T,m,[x(2),y(2)]);

i = 3;

while (i < n)
 [ptx, pty] = acesa_pilha(T,m);  % ponto no topo de T
 [mtx, mty] = acesa_pilha2(T,m); % ponto emabaixo de (ptx, pty) em T
 
 if (left([mtx, mty], [ptx, pty], [x(i), y(i)]))
  [T, m]   = insere_pilha(T,m,[x(i), y(i)]);
  i = i + 1;
 else
  [T, m, xx, yy] = remove_pilha(T,m);
 end
end

% vazia a pilha T com os pontos do fecho convexo de (sx, sy)
% na ordem anti-horaria

c = []; k = 1;
s = m;
while ( pilha_vazia(T,m) == False )
 [T, m, a, b] = remove_pilha(T,m);
 c(s-k+1) = a + j*b;
 k = k + 1;
end



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% A funcao left retorna 1 se o ponto c esta a esquerda da reta que pasa
% pelos pontos a e b, caso contrario retorna 0.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function b = left(a, b, c)

if (area2(a,b,c) > 0)
 b = 1;  
else
 b = 0; 
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% A funcao area2 retorna duas vezes a area sinalizada do triangulo 
% determinado pelos pontos a, b e c. Se a, b e c aparecem na fronteira 
% do triangulo nesta ordem ao percorrermos a fronteira no sentido 
% anti-horario o valor da area sinalizada sera positivo, caso contrario 
% sera negativo.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function a = area2(a, b, c)

a = a(1)*b(2)-a(2)*b(1)+a(2)*c(1)-a(1)*c(2)+b(1)*c(2)-c(1)*b(2);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function arctang = atan_modif(y,x)

    L = find(x ~= 0); arctang(L) = atan(y(L)./x(L));
    I = find(x == 0); arctang(I) = pi/2;
    
    q = length(L);
    for k = 1:q
     if (x(L(k)) < 0)
      arctang(L(k)) = arctang(L(k)) + pi;
    end
    end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [xt,yt] = remove_pont_reta(x,y)
    I0=[]; xt=x; yt=y;
    for i=2:(length(x)-1)
        if abs(area2([x(i-1) y(i-1)], [x(i) y(i)], [x(i+1) y(i+1)])) <= 0.0000000001
            I0=[I0 i];
        end
    end
    xt(I0)=[]; yt(I0)=[];
